<template>
  <div>
    <b-overlay
      :show="loading"
      :variant="'white'"
      :opacity="0.9"
      :blur="'2px'"
      style="padding: 1px;"
    >
      <div class="main-resource">

        <div class="form-row file-row">
          <div class="form-group col-2">
            <div class="format">
              {{
                resourceDataFormats.length && resource.data_source.data_format ?
                resourceDataFormats.find(el => el.id === resource.data_source.data_format).codename :
                ''
              }}
            </div>
          </div>
          <div class="form-group col-10" style="display: flex;">
            <div
              v-for="filePath of resource.data_source.href"
              :key="filePath"
              class="file-name"
            >
              {{ filePath.split('/').slice(-1)[0] }} 
              <i v-if="dataSourceInfos && dataSourceInfos.file">({{ fileSize }})</i>
            </div>
            <div class="resource-form-footer">
              <b-button
                variant="danger"
                @click="() => {
                if (type === 'resource') {
                  isDeleteResourceFileModalOpen = true
                } else {
                  deleteResource()
                }
              }"
              >
                Supprimer
              </b-button>
              <b-button
                v-if="userData.is_superuser"
                variant="outline-secondary"
                @click="isUpdateResourceFileModalOpen = true"
              >
                Modifier
              </b-button>
            </div>
          </div>
        </div>

        <div class="form-row">
          <div class="form-group col-12">
            <label class="required">Nom</label>
            <ValidationProvider ref="display_name" rules="required" :name="`Nom ${type === 'resource' ? 'ressource' : 'annexe'}`" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.display_name"
                  class="form-control"
                  type="text"
                  :placeholder="`Nom ${type === 'resource' ? 'de la ressource' : ' de l\'annexe'}`"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-12">
            <label>Description</label>
            <textarea
              v-model="form.description"
              class="form-control"
            />
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-6">
            <label class="required">Type</label>
            <ValidationProvider ref="kind" rules="required" name="Type" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <Multiselect
                  v-model="form.kind"
                  :options="resourceKinds"
                  :class="classes"
                  track-by="id"
                  label="display_name"
                  select-label=""
                  selected-label=""
                  deselect-label=""
                  :searchable="false"
                  placeholder="Sélectionner un type de ressource"
                />
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
          <div class="form-group col-6">
            <label :class="type === 'resource' ? 'required' : ''">
              Date de dernière mise à jour
            </label>
            <ValidationProvider
              ref="last_update_date"
              :rules="type === 'resource' ? 'required' : ''"
              :name="`Date de dernière mise à jour ${type}`"
              v-slot="{ classes, errors }"
            >
              <div class="control" :class="type === 'resource' ? classes : ''">
                <input
                  v-model="form.last_update_date"
                  :class="{ empty: !form.last_update_date}"
                  class="form-control"
                  type="date"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
      </div>
    </b-overlay>
    <UpdateFTPResourceModal
      :open="isUpdateResourceFileModalOpen"
      :format="resourceDataFormats.find(el => el.id === resource.data_source.data_format)"
      @hide="isUpdateResourceFileModalOpen = false"
      @update="updateFTP"
    />
    <DeleteResourceModal
      :open="isDeleteResourceFileModalOpen"
      :resource="resource"
      @hide="isDeleteResourceFileModalOpen = false"
      @delete="deleteResource"
    />
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import resourcesAPI from '@/api/resourcesAPI.js';
import UpdateFTPResourceModal from '@/components/ResourcesModals/UpdateFTPResourceModal.vue';
import DeleteResourceModal from '@/components/ResourcesModals/DeleteResourceModal.vue';
import Multiselect from 'vue-multiselect';
import { fileConvertSize } from '@/utils';
import axios from 'axios';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'FTPResourceEditor.vue',

  components: {
    UpdateFTPResourceModal,
    DeleteResourceModal,
    ValidationObserver,
    ValidationProvider,
    Multiselect
  },

  props: {
    resource: {
      type: Object,
      default: () => {
        return {}
      }
    },
    resourceData: {
      type: Object,
      default: () => {
        return {}
      }
    },
    type: {
      type: String,
      default: 'resource'
    }
  },

  data() {
    return {
      loading: false,
      dataSourceInfos: null,
      isUpdateResourceFileModalOpen: false,
      isDeleteResourceFileModalOpen: false,
      form: {
        display_name: null,
        description: null,
        kind: null,
        last_update_date: null
      }
    }
  },

  computed: {
    ...mapState('user-login', [
      'userData'
    ]),
    ...mapState('datasets', [
      'currentDataset'
    ]),
    ...mapState('resources', [
      'resourceDataFormats',
      'resourceKinds'
    ]),

    fileSize() {
      return fileConvertSize(this.dataSourceInfos.file.size);
    },

    isFormChanged() {
      return this.form.display_name !== this.resource.display_name ||
        this.form.description !== this.resource.description ||
        this.form.kind !== this.resource.kind ||
        this.form.last_update_date !== this.resource.last_update_date;
    }
  },

  async created() {
    this.loading = true;
    if (this.resourceDataFormats.length === 0) {
      this.GET_RESOURCE_DATA_FORMATS();
    }
    if (this.resourceKinds.length === 0) {
      this.GET_RESOURCE_KINDS();
    }
    if (this.resource.data_source._location) {
      const response = await resourcesAPI.getResourceDataSource(this.resource.data_source._location);
      this.dataSourceInfos = response;
    }
    this.form.display_name = this.resource.display_name;
    this.form.description = this.resource.description;
    this.form.kind = this.resource.kind;
    this.form.last_update_date = this.resource.last_update_date;
    this.loading = false;
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.isUpdateResourceFileModalOpen = false;
      this.isDeleteResourceFileModalOpen = false;
    });
  },

  methods: {
    ...mapMutations('resources', [
      'SET_RESOURCES_FILTERS',
    ]),
    ...mapActions('datasets', [
      'GET_DATASET_DETAIL',
    ]),
    ...mapActions('resources', [
      'GET_RESOURCE_DATA_FORMATS',
      'GET_RESOURCE_KINDS',
      'GET_RESOURCES_LIST',
      'DELETE_RESOURCE_FROM_DATASET',
      'DELETE_RESOURCE',
      'PATCH_RESOURCE'
    ]),

    resetForm() {
      this.form = {
        display_name: this.resource.display_name,
        description: this.resource.description,
        kind: this.resource.kind,
        last_update_date: this.resource.last_update_date
      }
    },

    updateResourceInfos() {
      if (this.isFormChanged) {
        this.loading = true;
        this.PATCH_RESOURCE({
          id: this.resource.id,
          data: {
            display_name: this.form.display_name,
            description: this.form.description,
            kind: this.form.kind,
            last_update_date: this.form.last_update_date
          },
          datasetId: this.currentDataset.id
        }).then(() => {
          this.loading = false;
        });
      }
    },

    updateFTP(e) {
      this.$emit('update', {
        ...e,
        id: this.resource.data_source.id,
        type: this.type
      });
      this.isUpdateResourceFileModalOpen = false;
    },

    deleteResource() {
      // Find dataset from which resource needs to be removed
      const resourceToDatasetId = this.resource.datasets.find(el => el.dataset_id === this.currentDataset.id).id;
      const resourceDataToDatasetId =
        this.resourceData && this.resourceData.datasets ?
          this.resourceData.datasets.find(el => el.dataset_id === this.currentDataset.id).id :
          null;

      this.loading = true;
      axios.all([
        this.DELETE_RESOURCE_FROM_DATASET({
          resourceToDatasetId: resourceToDatasetId,
          resource: this.resource
        }),
        ... resourceDataToDatasetId ? [this.DELETE_RESOURCE_FROM_DATASET({
          resourceToDatasetId: resourceDataToDatasetId,
          resource: this.resourceData
        })] : []
      ])
        .then(() => {
          if (this.type === 'resource') {
            axios.all([
              this.DELETE_RESOURCE(this.resource),
              ... resourceDataToDatasetId ? [this.DELETE_RESOURCE(this.resourceData)] : []
            ])
          }
          this.$emit('delete');
          this.loading = false;
        })
        .catch((err) => {
          console.error(err);
          this.loading = false;
        });
    }
  }
}
</script>

<style lang="less" scoped>

.main-resource {
  margin: 0.5em 0 1em 1em;
  padding: 1em 1.5em 0.5em 0.5em;
  border: 2px solid #9BD0FF;
}

.file-row {
  margin: -1em 0 1.5em 0.75em;
  padding: 2em 0 0em;
  border-bottom: solid 1px #9BD0FF;
}

.format {
  width: 100%;
  text-align: center;
  padding: 5px 10px;
  background-color: rgb(90, 90, 90);
  color: white;
  font-weight: 600;
}

.file-name {
  padding: 5px 10px;
  font-weight: 600;
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
  color: rgb(90, 90, 90);
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
  i {
    font-size: 0.9em;
  }
}

.resource-form-footer {
  display: flex;
  width: fit-content;
  justify-content: flex-end;
  margin: 0 0 1em 1em;
  button.btn-primary {
    border: 2px solid #9BD0FF;
    border-radius: 8px;
    margin-left: 1.5em;
  }
  button.btn-outline-secondary {
    background-color: #F7F8FA;
    border: 2px solid #A9B2B9;
    border-radius: 8px;
    color: #2F3234;
  }
  button.btn-outline-secondary:hover {
    color: white;
    background-color: #4b4b4b;
  }
}

button.btn-danger {
  border: 2px solid #ff9b9b;
  border-radius: 8px;
  margin-right: 1.5em;
}

</style>
